﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Charting;

namespace wpf_ChartView__980028
{
    public class CustomStyleSelector : StyleSelector
    {
        private Dictionary<Brush, Style> brushToStyleDict = new Dictionary<Brush, Style>();

        public override Style SelectStyle(object item, DependencyObject container)
        {
            DataPoint datapoint = (DataPoint)item;
            ChartDataFlatness dataItem = (ChartDataFlatness)datapoint.DataItem;
            Style style = this.GetOrCreateStyle(dataItem.Brush);

            return style;
        }

        private Style GetOrCreateStyle(Brush brush)
        {
            Style style;
            if (!this.brushToStyleDict.TryGetValue(brush, out style))
            {
                style = new Style(typeof(Path));
                style.Setters.Add(new Setter(Path.FillProperty, brush));
                this.brushToStyleDict[brush] = style;
            }

            return style;
        }
    }
}
